//Visitor Tracker 1.0 Karl O'Meara http://www.kbytes.co.uk
//Copyright 17 Feb 2015
//
//Very easy method to track the referring source of visitors to your website. 
//You will be informed of their source on e.g. your "Contact Us" page enquiry form, on email messages, or phone calls to you.
//
//This is done via a short code that describes the referring site.
//
//It is six letter code (length can be changed) made up of characters from the referring site.
//
//E.g.  Say you get a referrer from a site http://canada.bedandbreakfasts.net/ the short code will be CNDNET
//      From Google.com the short code will be GGLCM
//      From Google.co.uk the short code will be GGLCUK  
//
//For Contact Us Forms an extra field called 'visitortrackerform' is passed with the short code describing the referrering site.
//For Email Addresses a short code is appended to the Subject Line e.g.   Subj:  Trips to NewZealand - REF:GGLCUK
//For Phone Numbers a short code is appended on the web page after the phone number e.g.  Please call us on +442070436937 Ref: GGLCUK  - you then ask the caller for the Ref: Code
//
//LICENCE:  
//You must keep this help text at the start of the script.
//You must either put a link to www.kbytes.co.uk and write a short description.
//Or follow on Twitter https://twitter.com/imbendecko and tweet a link to http://www.kbytes.co.uk/Articles.asp?articleid=68
//Or You can buy me a beer via Paypal!

//INSTRUCTIONS:
//Install this script in the HEAD section of every page where traffic might enter the site e.g. not needed on-logged in or Admin pages.

//Then depending on which you use: Contact us Forms, Email Addresses, or Phone Numbers.

//Contact Us forms:
//add a HIDDEN field as   <INPUT ID="visitortracker" Name="visitortrackerform" TYPE="hidden" VALUE="">
//and after the </FORM> tag copy the script below and uncomment it
//Your webdesigner then needs to include that field in their application same as the Name or Address etc fields that they are already capturing

//Email messages:
//add a CLASS attribute with value visitortrackeremail to any <A HREF="mailto:"> tags e.g.  class="visitortrackeremail"
//and after the tag copy the script below and uncomment it

//Phone Numbers:
//add a SPAN segment after any phone numbers you display E.g.  +44 2070436939  <span class="visitortrackerphone"></span>
//and after the </span> tag copy the script below and uncomment it
//when viewed on the website it will display a message "REF: XXXX" where XXXX is a short code for the referrering website see above.

//The script commented out below only need to run once on each page, it should be included AFTER any controls that will be updated.

//<script>
//updateClassSpan();
//</script>


//SETTINGS: IMPORTANT Change these to what you require

var visitortrackertaglength = 6;  //recommended min 6 more - must be even number.
// This is the length of the Short Code described above
// The longer it is easier to understand.  E.g.  At length 4 tripadvisor.com referrers will be shown as TRCM, at 6 TRPRCM, at 8 TRPDSRCM and at 10 TRPDVSRCM
// However the downside is that for people calling clients they have to recite a longer tracking code over the phone if you are using that method of capture.

var decider = 'firstWins';  //or can be 'firstWins' or 'lastWins'  
//determines if the first website to referrer this visitor is stored.
//or if the last one is the winner.  Recommended 'firstWins' setting
//as it the first site that should get credited with telling your customer
//about your website.  Later on your visitor might use e.g. Google to return to the
//site to contact you after they have researched the market, but Google didn't originally  
//introduce your product to the client.

var expiryDays = 30;  //affects only 'firstWins'
//how long the first site is recorded.  After this period a different site might will replace the firstWins site.
//30 days is an industry standard.

//END SETTINGS

//That's it!  For "Contact us" Forms you will need to set your webserver to accept this new hidden field and include it on any message or display to you.

//SCRIPT CODE BELOW:
var referrer = extractDomain(document.referrer);
var currentDomain = extractDomain(window.location.host);

if (visitortrackerGetCookie('offsitereferrer') == '' || (decider = 'lastWins' && referrer != currentDomain )) {
    //it is nothing. Must be first load So lets set it
    visitortrackerSetCookie('offsitereferrer', createShortCode(referrer,visitortrackertaglength), expiryDays)
    //cookie set to the referring page for Xdays.
}

function visitortrackerSetCookie(cname, cvalue, exdays) {
    var d = new Date();
    d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
    var expires = "expires=" + d.toGMTString();
    document.cookie = cname + "=" + cvalue + "; " + expires;
}

function visitortrackerGetCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for (var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') c = c.substring(1);
        if (c.indexOf(name) != -1) {
            return c.substring(name.length, c.length);
        }
    }
    return "";
}

function createShortCode(urlToCompress,visitortrackertaglength) {
//this removes any vowels from the url, should be sufficient to 
//still determine the origin of the visitor
 var consonants = 'bcdfghjklmnpqrstvwxyz'.toUpperCase();
 var removedVowels = ''
 
 urlToCompress = urlToCompress.toUpperCase().replace('WWW.', ''); //get rid of any www. which does not help indent.
  
 for (var i=0;i<urlToCompress.length;i++) {
	//loop round the url. pulling ones that are contained in the consonants 
	var currentChar = urlToCompress.substr(i, 1);
	 if (consonants.indexOf(currentChar) > -1 ) {
		 //we found it
		 removedVowels = removedVowels + urlToCompress.substr(i, 1);
	 }
 }
  //now we compress that to however many chars required
  var fromStart = 0;
  var fromEnd = removedVowels.length;
  var foundChars = 0;
  var shortCode = '';
  var shortCodeStart = '';
  var shortCodeEnd = '';
   
  visitortrackertaglength = parseInt(visitortrackertaglength / 2);  //because we coming from both sides
  
  if (removedVowels.length <=  visitortrackertaglength) {
	  //we don't need to remove any
	  shortCode = removedVowels;
  }
  else
  {	 //loop round taking chars from start and end
     do  
   {  shortCodeStart = shortCodeStart +  removedVowels.substr(fromStart, 1);
	  fromStart++;
	  shortCodeEnd =  removedVowels.substr(fromEnd - 1 , 1) + shortCodeEnd;
	  fromEnd--;
	  foundChars++;
   }
   while (foundChars < visitortrackertaglength)
   shortCode = shortCodeStart + shortCodeEnd;
  }
 
 if (shortCode == '') {
	shortCode = 'Direct'; 
 }
  
 return shortCode;
}

function extractDomain(url) {
    var domain;
    //find & remove protocol (http, ftp, etc.) and get domain
    if (url.indexOf("://") > -1) {
        domain = url.split('/')[2];
    }
    else {
        domain = url.split('/')[0];
    }
   //find & remove port number
    domain = domain.split(':')[0];
    return domain;
}

function updateClassSpan() {
	
 var shortCode = visitortrackerGetCookie('offsitereferrer');
 
 if (shortCode == '') {
		   //no code, must have no referrer i.e. direct to website
		   shortCode = 'Direct';
	 }	

 if(document.getElementById('visitortrackerform')){
   document.getElementById('visitortrackerform').value = shortCode;  //update any form hidden element.
} 
	
var spans = document.getElementsByClassName("visitortrackerphone");

for (var i = spans.length - 1; i >= 0; i--)
 {
		 spans[i].innerHTML = 'Ref: '+ shortCode;
	 }
 
var mailtos = document.getElementsByClassName("visitortrackeremail");

for (var i = mailtos.length - 1; i >= 0; i--)
 {
	 var currentMailSnippet = mailtos[i].href;
	 
	  if (currentMailSnippet.toLowerCase().indexOf('?subject=') == -1 ) {
		//it does not already contain ?Subject, then add the ?Subject=
		  mailtos[i].href = mailtos[i].href + '?Subject=Ref: '+shortCode;
	 }
	  else 
	  {  //it has ?Subject=Message From Website already, just add our Ref code.
		  if (currentMailSnippet.toLowerCase().indexOf('ref:') == -1 ) {
		//it does not contains Ref:
		  mailtos[i].href = mailtos[i].href + ' Ref: '+shortCode;
	     }
	  }
   }
}
//END OF SCRIPT

//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//THE SOFTWARE.